package com.ims.eval.service.impl;

import com.ims.eval.config.CustomException;
import com.ims.eval.entity.OrganizationEvaluationInfo;
import com.ims.eval.dao.OrganizationEvaluationInfoMapper;
import com.ims.eval.entity.ResponsibilityIndicatorInfo;
import com.ims.eval.entity.dto.request.OrganizationEvaluationInfoUpdateDTO;
import com.ims.eval.entity.dto.request.ResponsibilityIndicatorInfoUpdateDTO;
import com.ims.eval.entity.dto.response.OrganizationEvaluationInfoResDTO;
import com.ims.eval.entity.dto.response.ResponsibilityIndicatorInfoResDTO;
import com.ims.eval.service.IOrganizationEvaluationInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 * 考评指标明细

 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-03-16
 */
@Service
public class OrganizationEvaluationInfoServiceImpl extends ServiceImpl<OrganizationEvaluationInfoMapper, OrganizationEvaluationInfo> implements IOrganizationEvaluationInfoService {

	@Override
	public Map finishValueList(String organizationEvaluationId, String dept) {

		List<OrganizationEvaluationInfoResDTO> list = baseMapper.selectListEvaluationInfoId(organizationEvaluationId,dept,"");//默认获取指定的怎目标

		Map<String  ,List<OrganizationEvaluationInfoResDTO>> map  = list.stream().collect(Collectors.groupingBy(OrganizationEvaluationInfoResDTO::getIsQuantified));
		map.put("quantifiedList", map.remove("是"));
		map.put("nonQuantifiedList", map.remove("否"));
		return map;
	}

	@Transactional
	@Override
	public boolean saveBatchDto(List<OrganizationEvaluationInfoUpdateDTO> evaluationInfoUpdateDTOS) {
		for (OrganizationEvaluationInfoUpdateDTO entity : evaluationInfoUpdateDTOS) {
			OrganizationEvaluationInfo organizationEvaluationInfo = baseMapper.selectById(entity.getId());

			organizationEvaluationInfo.setQuantifiedValue(entity.getQuantifiedValue());//量化值
			organizationEvaluationInfo.setNonQuantifiedValue(entity.getNonQuantifiedValue());//非量化值
			organizationEvaluationInfo.setUpdateTime(new Date());//更新时间
			organizationEvaluationInfo.setUpdateBy(entity.getUpdateBy());//更新者
			organizationEvaluationInfo.setRemark(entity.getRemark());//备注

			boolean b = super.saveOrUpdate(organizationEvaluationInfo);
			if(!b){
				throw new CustomException("更新失败");
			}
		}
		return true;
	}
}
